//$Id: resource-util.cc,v 1.5 2002/01/01 21:23:39 cactus Exp $ -*- c++ -*-

/* Guikachu Copyright (C) 2001-2002 RDI Gerg <cactus@cactus.rulez.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "resource-util.h"

using namespace Guikachu;

const std::string Resources::prefix_from_type (Resources::Type type)
{
    std::string type_id;
    
    switch (type)
    {
    case Resources::RESOURCE_STRING:
	type_id = "STRING";
	break;
    case Resources::RESOURCE_STRINGLIST:
	type_id = "STRINGLIST";
	break;
    case Resources::RESOURCE_DIALOG:
	type_id = "DIALOG";
	break;
    case Resources::RESOURCE_MENU:
	type_id = "MENU";
	break;
    case Resources::RESOURCE_FORM:
	type_id = "FORM";
	break;
    case Resources::RESOURCE_BLOB:
	type_id = "BLOB";
	break;
    }

    return type_id;
}

const std::string Resources::type_id_from_type (Resources::Type type)
{
    std::string type_id;
    
    switch (type)
    {
    case Resources::RESOURCE_STRING:
	type_id = "string";
	break;
    case Resources::RESOURCE_STRINGLIST:
	type_id = "stringlist";
	break;
    case Resources::RESOURCE_DIALOG:
	type_id = "dialog";
	break;
    case Resources::RESOURCE_MENU:
	type_id = "menu";
	break;
    case Resources::RESOURCE_FORM:
	type_id = "form";
	break;
    case Resources::RESOURCE_BLOB:
	type_id = "blob";
	break;
    }

    return type_id;
}
